找到字符串中所有字母异位词(medium)

一题目链接

找到字符串中所有字母异位词

二题目描述

三解法(滑动窗口 + 哈希表)

3.1算法思路:

◦ 因为字符串 p 的异位词的长度一定与字符串 p 的长度相同,所以我们可以在字符串 s 中构
造一个长度为与字符串 p 的长度相同的滑动窗口,并在滑动中维护窗口中每种字母的数量;
◦ 当窗口中每种字母的数量与字符串 p 中每种字母的数量相同时,则说明当前窗口为字符串 p
的异位词;
◦ 因此可以用两个大小为 26 的数组来模拟哈希表,一个来保存 s 中的子串每个字符出现的个
数,另一个来保存 p 中每一个字符出现的个数。这样就能判断两个串是否是异位词。

3.2C++ 算法代码:

cpp 复制代码
class Solution
{
    public:
        vector<int> findAnagrams(string s, string p)
        {
            vector<int> ret;
            int hash1[26] = { 0 }; // 统计字符串 p 中每个字符出现的个数
            for(auto ch : p) hash1[ch - 'a']++;
            int hash2[26] = { 0 }; // 统计窗口里面的每一个字符出现的个数
            int m = p.size();
            for(int left = 0, right = 0, count = 0; right < s.size(); right++)
            {
                char in = s[right];
                // 进窗口 + 维护 count
                if(++hash2[in - 'a'] <= hash1[in - 'a']) count++;
                if(right - left + 1 > m) // 判断
                {
                    char out = s[left++];
                    // 出窗口 + 维护 count
                    if(hash2[out - 'a']-- <= hash1[out - 'a']) count--;
                }
                // 更新结果
                if(count == m) ret.push_back(left);
             }
            return ret;
        }
};

3.2.1C++结果

3.3Java 算法代码:

java 复制代码
class Solution
{
    public List<Integer> findAnagrams(String ss, String pp)
    {
        List<Integer> ret = new ArrayList<Integer>();
        char[] s = ss.toCharArray();
        char[] p = pp.toCharArray();
        int[] hash1 = new int[26]; // 统计字符串 p 中每一个字符出现的个数
        for(char ch : p) hash1[ch - 'a']++;
        int[] hash2 = new int[26]; // 统计窗口中每一个字符出现的个数
        int m = p.length;
        for(int left = 0, right = 0, count = 0; right < s.length; right++)
        {
            char in = s[right];
            // 进窗口 + 维护 count
            if(++hash2[in - 'a'] <= hash1[in - 'a']) count++;
            if(right - left + 1 > m) // 判断
            {
                char out = s[left++];
                // 出窗口 + 维护 count
                if(hash2[out - 'a']-- <= hash1[out - 'a']) count--;
            }
            // 更新结果
            if(count == m) ret.add(left);
        }
        return ret;
    }
}

3.3.2Java结果

四细节与避坑

  1. 边界处理 :如果 p.size() > s.size(),直接返回空数组,避免越界。
  2. 数组对比 :用 memcmp 直接对比两个 26 元素的数组,比循环判断更高效。
  3. 窗口滑动逻辑 :
    • 左边界索引:i - n2
    • 新窗口起始索引:i - n2 + 1
  4. 内存优化:全程不用创建子串,只用两个 26 大小的数组,空间复杂度 O (1),不会超内存。
相关推荐
FPGA信号处理9 分钟前
【凸优化】第一节课(下):保凸运算、分离超平面与 Farkas 引理
人工智能·算法·机器学习
怕浪猫26 分钟前
Agent 的记忆系统怎么设计?面试官想听的是这个
算法·面试·github
C++ 老炮儿的技术栈29 分钟前
C++ const 的3个核心作用
服务器·c语言·c++·算法·c
有毒的教程42 分钟前
Dev-C++ 避免爆栈(Stack Overflow)完整方案
c++·算法·深度优先
在所不辞兄1 小时前
刚性问题误差容限设置技巧
深度学习·神经网络·算法·机器学习
啊啊啊啊啊!!!!1 小时前
unordered_map和unordered_set的使用
算法
java_nnnn1 小时前
LeetCode刷题双指针(快乐数+盛最多水的容器)Java
算法·leetcode·职场和发展
yi01110 小时前
LeetCode 219:存在重复元素 II——哈希表记录“最近一次出现的位置”
数据结构·人工智能·笔记·python·算法·leetcode·哈希表
YangYang9YangYan11 小时前
2027 秋招|数据科学与大数据技术面试项目价值回答思路,告别纯代码描述
大数据·面试·职场和发展
灯澜忆梦13 小时前
【面向对象编程C++】| 基础语法
java·c++·算法